/***
 * Created by Bryan Tai and Carolyn Shen Mar 25, 2016
 * Created for Project 4 of CPSC 314
 *
 * Picking inspired by Soledad penades
 * https://github.com/sole/three.js-tutorials/blob/master/object_picking/main.js
 *http://soledadpenades.com/articles/three-js-tutorials/object-picking/
*/

var picker = (function (V) {

  var raycaster = new THREE.Raycaster();
  raycaster.far = V.PLAYER_REACH;
  raycaster.near = 1;
  var pickedObject = null;
  var centreVector = new THREE.Vector2( 0,0);
  
  function getPickedObject(){
	  return pickedObject;
  }

  function updatePicked(pickableObjects){

	raycaster.setFromCamera( centreVector,V.camera);
	//This function requires an ARRAY, not an OBJECT so "objects" will not work.
	var intersects = raycaster.intersectObjects( pickableObjects );
	
	//reset all materials of pickableObjects
	//In order for this to work nicely, the materials should all be textured so RGB values all = 1;
	
	for(i in pickableObjects){
		if("material" in pickableObjects[i]){
			pickableObjects[i].material.color.set( 0xffffff );
		}
		//TODO can't get collection working for now....
		//else{
		//	//current object is a collection of meshs
		//	var childMeshs = pickableObjects[i].children;
		//	for(j in childMeshs){
		//		childMeshs[j].material.color.set( 0xffffff );
		//	}
		//}
	}
	pickedObject = null;
	if(intersects.length > 0){
		pickedObject = intersects[ 0 ].object;
		pickedObject.material.color.set( 0xff0000 );
		//for(c in pickedObject.children){
		//	pickedObject.children[c].material.color.set( 0xff0000 );
		//}
	}
  }
  return {
	  updatePicked: updatePicked,
	  getPickedObject: getPickedObject
  };
})(V);